class Category
  attr_accessor :name, :label
  def initialize(*args)
    @name = args[0]
    @label = args[1] || args[0]
  end
end

class << Category
  include Enumerable

  CATEGORY = if Setting::CATEGORY
               Setting::CATEGORY.collect{|a| Category.new(*a)}
             else
               nil
             end

  def exist?
    CATEGORY
  end

  def [](name)
    CATEGORY.find{|category| category.name == name}
  end

  def keys
    CATEGORY.collect{|category| category.name}
  end

  def each
    CATEGORY.each do |category|
      yield(category)
    end
  end

end



