def active
  true
end

INDEX_PATH = './index.shtml'

def init
  generate([])
end

def html_header(cgi)
  cgi.p {
    cgi.a('href' => 'regist_sidebar.html') {
      'SidebarϿ'
    } +
    '/' +
    cgi.a('href' => Setting::SCRIPT_URL) {
      'ԥ˥塼'
    } + cgi.br +
      (Setting::REFRESH_INTERVAL / 60).to_s +
      'ʬֳ֤ǹ桢ǽܻ֤' +
      Time.now.localtime.strftime('%Y/%m/%d %H:%M') +
      'Ǥ'
  }
end
   
def html_category(cgi)
  return '' unless Category.exist?

  cgi.a('href' => INDEX_PATH) { 'TOP' } + 
  '/' +
  Category.collect{|category|
    cgi.a('href' => "#{category.name}.shtml") { category.label }
  }.join('/')
end

def html_site(cgi, site)
  comment = 
    if site.category
      comment = site.category.collect{|category|
      Category.keys.include?(category) ? Category[category].label : nil
    }
    else
      []
    end
  if site.comment && ! site.comment.empty?
    comment << site.comment
  end
  comment.compact!
  if comment.empty?
    comment = ''
  else
    comment = ' [' + comment.join('/') + ']'
  end  

  if site.valid_modified
    Time.at(site.last_modified).localtime.strftime('%Y/%m/%d %H:%M')
  else
    '----/--/-- --:--'
  end +
  '&nbsp;&nbsp;' +
  cgi.a('href' => site.modify_specific_url, 'target' => '_blank') { '' } +
  cgi.a('href' => site.modify_specific_url) { CGI::escapeHTML(site.title) } +
  '&nbsp;&nbsp;' +
   CGI::escapeHTML(site.author) +
   cgi.small{ comment }
end

def html_sites(cgi, sites)
  cgi.ul {
    sites.collect {|site|
      cgi.li {
        html_site(cgi, site)
      }
    }
  }
end

def html_footer(cgi)
  cgi.p {
      'Υڡι' +
      cgi.a('href' => 'ruriko.hina'){ 'ruriko.hina' } + '' +
      cgi.a('href' => 'ruriko.hina.gz'){ 'ruriko.hina.gz' } + '' +
      cgi.a('href' => 'ruriko.di'){ 'ruriko.di' } + '' +
      cgi.a('href' => 'ruriko.di.gz'){ 'ruriko.di.gz' } + '' +
      cgi.a('href' => 'ruriko.lirs'){ 'ruriko.lirs' } + '' +
      cgi.a('href' => 'ruriko.lirs.gz'){ 'ruriko.lirs.gz' } + 
      'γƼǼǤޤ' +
      cgi.br
  } +
    cgi.hr +
    cgi.a ('href' => "mailto:#{Setting::ADMIN_EMAIL}") {
    "#{Setting::ADMIN_NAME}(#{Setting::ADMIN_EMAIL})"
  } +
    cgi.hr +
    cgi.a ('href' => Ruriko::AUTHOR_URL) {
     Ruriko::USER_AGENT
  }
end

def html(cgi, title)
  html = cgi.html {
    cgi.head {
      cgi.meta('http-equiv' => 'Content-Type',
               'content' => 'text/html; charset=iso-2022-jp') +
      if Setting::REFRESH_INTERVAL
        cgi.meta('http-equiv' => 'Refresh',
                 'content' => Setting::REFRESH_INTERVAL.to_s)
      else
        ''
      end +
      cgi.title { title }
    } +
    cgi.body('text' => 'black',
             'bgcolor' => 'white') {
      cgi.h1 { title } +
      yield
    }
  }

  Kconv.kconv(html, Kconv::JIS, Kconv::EUC)
end
      
def generate(sites)
  cgi = CGI.new('html4')
  
  src = html(cgi, Setting::TITLE) {
    html_header(cgi) +
    html_category(cgi) + 
    html_sites(cgi, sites) +
    html_footer(cgi)
  }
  open(INDEX_PATH, 'w') do |file| file.write(src) end
  
  return unless Category.exist?

  Category.each do |category|
    src = html(cgi, "#{Setting::TITLE}/#{category.label}") {
      html_header(cgi) +
      html_category(cgi) + 
      html_sites(cgi, sites.select{|site|
                   site.category &&
                     site.category.include?(category.name)}) +
      html_footer(cgi)
    }
    open("#{category.name}.shtml", 'w') do |file| file.write(src) end
  end
end

      
