REGISTER_PATH = 'regist_sidebar.html'
SIDEBAR_PATH = 'sidebar.shtml'
BLANK_PATH = 'blank.html'

def active
  true
end

def init
  generate([])

  open(BLANK_PATH, 'w') do |file| file.write(Kconv.tojis(<<-"END")) end
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-2022-jp">
<title>blank</title>
<head>
<body bgcolor="white">
</body>
</html>
END

  open(REGISTER_PATH, 'w') do |file| file.write(Kconv.tojis(<<-"END")) end
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-2022-jp">
<script language="JavaScript">
<!--
function focus() {
  document.forms[0].school_code.focus();
}

function addSidebar() {
  var name = "#{Setting::TITLE}";
  var url = "#{Setting::HOME_URL}#{SIDEBAR_PATH}";
  var grayIcon = "#{Setting::HOME_URL}sidebar_gray.ico";
  var colorIcon = "#{Setting::HOME_URL}sidebar_color.ico";
  if ((typeof window.sidebar == "object")
      && (typeof window.sidebar.addPanel == "function")) {
    // [Netscape 6 / Mozilla]
    window.sidebar.addPanel (name, url, "");
    history.back();
  } else if ((typeof window.external == "object")
             && (typeof window.external.AddBar != undefined)) {
    // [Internet Explorer 6]
    window.external.AddBar (name, url, grayIcon, colorIcon, "", false, "full");
    history.back();
  }
}

addSidebar();

//-->
</script>
<title>#{Setting::TITLE} SideBar</title>
</head>
<frameset cols="160,*">
<frame src="#{SIDEBAR_PATH}" name="sidebar" marginwidth=5>
<frame src="#{BLANK_PATH}" name="_content">
<noframe>
<body>
</body>
</noframe>
</frameset>
</html>
END
end

def generate(sites)
  cgi = CGI.new('html4')

  html = cgi.html {
    cgi.head {
      cgi.meta('http-equiv' => 'Content-Type',
                'content' => 'text/html; charset=iso-2022-jp') +
      if Setting::REFRESH_INTERVAL
        cgi.meta('http-equiv' => 'Refresh',
                 'content' => Setting::REFRESH_INTERVAL.to_s)
      else
        ''
      end +
      cgi.title { Setting::TITLE }
    } +
    cgi.body('text' => 'black', 
             'bgcolor' => 'white') {
      cgi.strong { cgi.big { Setting::TITLE } } + cgi.br +
      cgi.small { Time.now.localtime.strftime('%m/%d %H:%M') + '' } +
      cgi.br +
      cgi.a('href' => SIDEBAR_PATH) { 'Reload' } +
      cgi.br + cgi.br +
      cgi.small {
        sites.collect{|site|
          cgi.a ('href' => site.modify_specific_url,
                 'target' => '_content') {
            "#{site.title}(#{site.author})" + cgi.br +
            if site.valid_modified
              Time.at(site.last_modified).localtime.strftime('%m/%d %H:%M')
            else
              '--/-- --:--'
            end +
            cgi.br + cgi.br
          }
        }
      } +
      cgi.hr +
      cgi.a ('href' => "mailto:#{Setting::ADMIN_EMAIL}") {
        "#{Setting::ADMIN_NAME}(#{Setting::ADMIN_EMAIL})"
      }
    }
  }

  open(SIDEBAR_PATH, 'w') do |file| file.write(Kconv.tojis(html)) end
end
