def active
  true
end

def extension
  'hina'
end

def import(input)
  sites = []

  hina = Kconv::toeuc(input.to_a.join)
  hina.scan(/<!--(HINA_.*?)-->.*?<a\s+href=['"]?(.*?)['"]?\s*>(.*?)<\/a>/i) do
    |matched|
    p matched
    site = Site.new
    site.url = site.target_url = matched[1]
    site.title = matched[2]
    case matched[0]
    when %r/HINA_OK\s+(\d+)\/(\d+)\/(\d+)\s+(\d+):(\d+)/
      time = Time.local($1.to_i, $2.to_i, $3.to_i, $4.to_i, $5.to_i).to_i
      site.author = ''
      site.last_modified = time
    end
    sites << site
  end
  sites
end

def export(output, sites)
  sites.each do |site|
    if ! site.last_modified
      output << '<!--HINA_UNKNOWN-->'
    elsif site.status == Site::Status::ERROR
      output << '<!--HINA_REMOTE_OUT-->'
    else
      output << 
        Time.at(site.last_modified).
        strftime('<!--HINA_OK %Y/%m/%d %H:%M [1]-->')
    end

    output << "<A HREF=\"#{site.url}\">#{site.title}</A>#{site.author}<BR>\n"
  end
end



