RECORD_HEADER = 'LIRS'

def active
  true
end

def extension
  'lirs'
end

def import(input)
  sites = []

  input.each do |line|
    next if /^#/.match(line)
    items = line.strip.split(/(?!\\),/, -1).collect{|item|
      item.gsub(/\\,/, ',').gsub(/\\\\/, '\\')
    }
    next unless items.size >= 11
    next unless items[0] == RECORD_HEADER

    site = Site.new
    site.last_modified = items[1].to_i
    site.last_detected = items[2].to_i
    site.content_length = items[4].to_i
    site.url = items[5]
    site.target_url = items[9].empty? ? items[5] : items[9]
    site.title = items[6]
    site.author = items[7]
    
    sites << site
  end

  sites
end

def export(output, sites)
  output << "# #{Ruriko::USER_AGENT} generated LIRS file\n"

  lag = Time.lag

  sites.each do |site|
    output << [
      RECORD_HEADER,
      site.last_modified || 0,
      site.last_detected || 0,
      lag,
      site.content_length || 0,
      site.url,
      site.title,
      site.author,
      '0',
      site.target_url == site.url ? '' : site.target_url,
      '',
      '' ].collect{|item|
      item.to_s.gsub(/,/, '\\,').gsub(/\\/, '\\\\')
    }.join(',') + "\n"
  end
end

  
  
