module Timezone
  TZ = {
    'GMT' => 0,
    'UTC' => 0,
    'UT' => 0,
    'WAT' => -1 * 3600,
    'AT' => -2 * 3600,
    'AST' => -4 * 3600,
    'EST' => -5 * 3600,
    'CST' => -6 * 3600,
    'MST' => -7 * 3600,
    'PST' => -8 * 3600,
    'YST' => -9 * 3600,
    'AHST' => -10 * 3600,
    'HST' => -10 * 3600,
    'NT' => -11 * 3600,
    'IDLW' => -12 * 3600,
    'CET' => 1 * 3600,
    'MET' => 1 * 3600,
    'MEWT' => 1 * 3600,
    'SWT' => 1 * 3600,
    'EET' => 1 * 3600,
    'BT' => 3 * 3600,
    'ZP4' => 4 * 3600,
    'ZP5' => 5 * 3600,
    'ZP6' => 6 * 3600,
    'WAST' => 7 * 3600,
    'CCT' => 8 * 3600,
    'JST' => 9 * 3600,
    'EAST' => 10 * 3600,
    'GST' => 10 * 3600,
    'IDLE' => 12 * 3600,
    'NZST' => 12 * 3600,
    'NZT' => 12 * 3600,

    'BST' => 0,
    'ADT' => -4 * 3600,
    'EDT' => -5 * 3600,
    'CDT' => -6 * 3600,
    'MDT' => -7 * 3600,
    'PDT' => -8 * 3600,
    'YDT' => -9 * 3600,
    'HDT' => -10 * 3600,
    'MEST' => 1 * 3600,
    'MESZ' => 1 * 3600,
    'SST' => 1 * 3600,
    'FST' => 1 * 3600,
    'WADT' => 7 * 3600,
    'EADT' => 10 * 3600,
    'NZDT' => 12 * 3600,
  }

  def tz2sec(tz)
    case tz
    when /\+(\d\d)(\d\d)/
      $1.to_i * 3600 + $2.to_i

    when /\-(\d\d)(\d\d)/
      - ($1.to_i * 3600 + $2.to_i)

    else 
      TZ[tz] || Time.lag
    end
  end

  module_function :tz2sec
end
